<?php

/**
 * Implementation of hook_views_tables()
 */
function cart_views_tables() {
  $tables['ec_cart_product'] = array(
    'name' => 'ec_product',
    'join' => array(
      'left' => array(
        'table'     => 'node',
        'field'     => 'vid'
      ),
      'right' => array(
        'field'     => 'vid'
      )
    ),
    'fields' => array(
      'addtocartlink' => array(
        'handler'   => 'cart_views_handler_add_to_cart_link',
        'name'      => t('Cart: Add to cart link'),
        'sortable'  => FALSFALSFALSFALSE,
        'notafield' => TRUE,
      )
    ),
  );
  return $tables;
}

/**
 * Field handler to give an add to cart link using product_link()
 */
function cart_views_handler_add_to_cart_link($fieldinfo, $fielddata, $value, $data) {
  $node = node_load($data->nid);
  $links = module_invoke('cart', 'link', 'node', $node, FALSE, TRUE);
  foreach (module_implements('link_alter') as $module) {
    $function = $module .'_link_alter';
    $function($node, $links);
  }
  if (is_array($links)) {
    $link = array_pop($links);
    $html = isset($link['html']) && $link['html'];
    if (!empty($link['href'])) {
      return l($link['title'], $link['href'], $link['attributes'], $link['query'], $link['fragment'], FALSE, $html);
    }
    elseif (!empty($link['title'])) {
      //Some links are actually not links, but we wrap these in <span> for adding title and class attributes
      if (empty($html)) {
        $link['title'] = check_plain($link['title']);
      }
      return '<span'. drupal_attributes($link['attributes']) .'>'. $link['title'] .'</span>';
    }
  }
}
