/* $Id; */

Drupal.ecCharge = {};

Drupal.ecCharge.bindAjaxResponse = function(data) {
  if (data.type == 'display') {
    $('#modalContent span.modal-title').html(data.title);
    $('#modalContent div.modal-content').html(data.output);

    // Bind forms to ajax submit.
    $('div.modal-content form').unbind('submit'); // be safe here.
    $('div.modal-content form').submit(function() {
      $(this).ajaxSubmit({
        url: data.url,
        data: '',
        method: 'post',
        after: Drupal.ecCharge.bindAjaxResponse,
        dataType: 'json'
      });
      return false;
    });
  }
  else if (data.type == 'submitted') {
    
  }
}

Drupal.ecCharge.createModal = function() {
  var html = '';
  html += '<div class="ec-charge-hidden">';
  html += '  <div id="ec-charge-modal">';
  html += '    <div class="ec-charge-modal-content">';
  html += '      <div class="modal-header">';
  html += '        <a class="close" href="#">';
  html +=            Drupal.settings.ecCharge.closeText + Drupal.settings.ecCharge.closeImage;
  html += '        </a>';
  html += '        <span class="modal-title">&nbsp;</span>';
  html += '      </div>';
  html += '      <div class="modal-content">';
  html += '      </div>';
  html += '    </div>';
  html += '  </div>';
  html += '  <div id="ec-charge-throbber">';
  html += '    <div class="ec-charge-throbber-wrapper">';
  html +=        Drupal.settings.ecCharge.throbber;
  html += '    </div>';
  html += '  </div>';
  html += '</div>';

  $('body').append(html);
};

/**
 * Display the modal
 */
Drupal.ecCharge.show = function() {
  $('#ec-charge-modal').modalContent({
    opacity: '.40', 
    background: '#fff'
  });
  $('#modalContent .modal-content').html($('div#ec-charge-throbber').html());
};

/**
 * Hide the modal
 */
Drupal.ecCharge.dismiss = function() {
  $('#ec-charge-modal').unmodalContent();
};

Drupal.ecCharge.autoAttachButton = function (path, button, select) {
  $('.'+button).click(function () {
    var s = $('.'+select).val();
    var url = '';
    if (s) {
      url = path + '/' + s;
    
      // show the empty dialog right away.
      Drupal.ecCharge.show();
      $.ajax({
        type: "GET",
        url: url,
        data: '',
        global: true,
        success: Drupal.ecCharge.bindAjaxResponse,
        error: function() { alert("Invalid response from server."); Drupal.ecCharge.dismiss(); },
        dataType: 'json'
      });
    }

    return false;
  });
};

$(document).ready(function () {
  Drupal.ecCharge.createModal();
  for (type in Drupal.settings.ecCharge['tables']) {
    Drupal.ecCharge.autoAttachButton(Drupal.settings.ecCharge['tables'][type]['addUrl'], Drupal.settings.ecCharge['tables'][type]['addButton'], Drupal.settings.ecCharge['tables'][type]['addSelect']);
  }
});
